<?php
/**
 * @copyright (c) Kufer Software GmbH, Loisachstrasse 4, D-84453 Mühldorf
 */

namespace Kufer\KuferTools\Basis\TeilnehmerInfo\TeilnehmerDetails;

use Kufer\KuferTools\Basis\Kursdetails\DetailsReiter\MerkeReiter\MerkeReiterUseCase as MerkeReiterUseCase;

abstract class TeilnehmerDetailsUseCase extends \Kufer\KuferTools\Basis\UseCase\EinzelTeilnehmerUseCase
{
  public function __construct($request)
  {
    parent::__construct($request, new TeilnehmerDetailsResponse());
  }

  public function action()
  {
    $this->resetSessionVars();
    $teilnehmer = $this->getTeilnehm($this->getRequestedIdentifier());
    $this->setTotalDatastr();

    return $this->getResponse($teilnehmer);
  }

  private function resetSessionVars()
  {
    \SessionOperations::setVarValueWTIntern('newTnStatusCode', '');
    \SessionOperations::setVarValueWTIntern('newTnWrongFields', '');
  }

  protected function setTotalDatastr()
  {
    return;
  }

  public function hasAccess($pToolsectionId = null)
  {
    
    if (!parent::hasAccess($pToolsectionId)) {
      return false;
    }
    if (!\GetOperations::isDefined('tnr')) {
      return false;
    }

    return true;
  }

  protected function getBackLink()
  {
    return 'index.php?tool_id=' . $this->getToolId();
  }

  protected function getBackButtonLabel()
  {
    return 'Zurück zur Übersicht';
  }

  protected function getResponse($teilnehmer)
  {
    $this->handleResponseStrategies();
    $this->response->teilnehmer = $teilnehmer;
    $this->setBenachbarteTnrsToResponse($teilnehmer);

    $this->response->reiter = $this->getReiter();
    $this->response->oeffneReiter = MerkeReiterUseCase::oeffneReiter($this->getToolId(), $this->getToolSectionId());

    $refererSessionPrefix = 'referer_tool' . $this->getToolSectionId() . '_';
    if (!empty($this->request->referer) && !empty($this->request->refererLabel)) {
      \Kufer\KuferTools\Utils\Referrer::aktualisiereReferrerInSession($this->getToolId(), $this->request->referer, $this->request->refererLabel, $refererSessionPrefix);
    }

    list($this->response->backLink, $this->response->backButtonLabel) = \Kufer\KuferTools\Utils\Referrer::getReferrerTupleFromSession($this->getToolId(), $this->getBackLink(), $this->getBackButtonLabel(), $refererSessionPrefix);

    $this->response->ueberschrift = $this->getUeberschrift($teilnehmer);
    $this->response->reiterButtons = $this->getButtons();

    $this->response->newTnStatusCode = $this->request->newTnStatusCode;
    $this->response->newTnWrongFields = $this->request->newTnWrongFields;

    return $this->response;
  }

  abstract protected function getButtons(): array;

  
  protected function getUeberschrift($teilnehmer)
  {
    return $this->response->sprachSettings->Teilnehmer['Singular']['Nominativ'] . '  ' . $teilnehmer->namevorname;
  }

  protected function setBenachbarteTnrsToResponse($teilnehmer)
  {
    $alleTnrs = $this->getTeilnehmerNummern();
    $index = \array_search($teilnehmer->id, $alleTnrs);

    if ($index !== false) {
      if (isset($alleTnrs[$index - 1])) {
        $this->response->previousTnr = $alleTnrs[$index - 1];
      }
      if (isset($alleTnrs[$index + 1])) {
        $this->response->nextTnr = $alleTnrs[$index + 1];
      }
    }
  }

  protected function getResponseStrategies()
  {
    return array(
        new \Kufer\KuferTools\Utils\ResponseStrategies\ResponseMitRahmen($this)
    );
  }

  protected function getReiter()
  {
    $result = array();
    $reiterBeschriftung = $this->getReiterBeschriftung();

    $reiterSeite = new \ReiterSeite($this->getToolSectionId(), $reiterBeschriftung);
    $reiterAry = $reiterSeite->getReiterKeysAry();
    $teilnehmerNr = isset($this->request->tnr) ? $this->request->tnr : '';
    $teilnehmerGuid = $this->request->tguid ?? null;
    foreach ($reiterAry as $reiter) {
      $recht = $reiterSeite->getRecht($reiter);
      if ($this->isRechtAllowed($recht)) {
        $reiterDm = new \Datamodul();
        $reiterDm->label = $reiterSeite->getLabel($reiter);
        $reiterDm->action = $reiterSeite->getAction($reiter); 
        $reiterDm->tnr = $teilnehmerNr;
        $reiterDm->tguid = $teilnehmerGuid;
        $reiterDm->toolId = $this->getToolId();
        $result[] = $reiterDm;
      }
    }

    return $result;
  }

  protected function getReiterBeschriftung()
  {
    return isset($this->toolSettings->reiterBeschriftung) ? $this->toolSettings->reiterBeschriftung : '';
  }
}

class TeilnehmerDetailsRequest
{
  public $tnr;
  public $tguid;
  public $referer;
  public $refererLabel;
  public $newTnStatusCode;
  public $newTnWrongFields;
}

class TeilnehmerDetailsResponse extends \Kufer\KuferTools\Basis\UseCase\ToolResponse
{
  public $teilnehmer;
  public $menuPunkte;
  public $reiter;
  public $previousTnr;
  public $nextTnr;
  public $reiterButtons;
  public $oeffneReiter;
  public $ueberschrift;
  public $backLink;
  public $backButtonLabel;
  public $newTnStatusCode;
  public $newTnWrongFields;
}